﻿/*
Version: 1.1

Release date: September 13th 2013

Author: Josip

Description: 
Hard break the text at predefined position. The default is column 75, but you can change that in the plugin file (variable WORDWRAPAT at the top of the file).

Instalation:
Unzip the "Wordwrap at 75" directory into the plugins directory.

Deployment:
Run the plugin from the plugins menu.
*/


////////////////////////
WORDWRAPAT = 75;
////////////////////////

// var t;
if (monkey.selectionLength == 0) {
  var oldPos = monkey.selectionStart;
  monkey.richTextBox.Text = wordwrap(monkey.richTextBox.Text, WORDWRAPAT, "\n", true);
  monkey.moveCaret(oldPos)
  monkey.scrollToCaret();
} else {
  monkey.selectedText = wordwrap(monkey.selectedText, WORDWRAPAT, "\n", true);
}

function trimBlanks(str) {
  return str.replace(/^ +| +$/mg, "");
}


function wordwrap(str, int_width, str_break, cut) {
  var m = ((arguments.length >= 2) ? arguments[1] : 75);
  var b = ((arguments.length >= 3) ? arguments[2] : "\n");
  var c = ((arguments.length >= 4) ? arguments[3] : false);

  var i, j, l, s, r;

  str += '';

  if (m < 1) {
    return str;
  }

  for (i = -1, l = (r = str.split(/\r\n|\n|\r/)).length; ++i < l; r[i] += s) {
    for (s = r[i], r[i] = ""; s.length > m; r[i] += s.slice(0, j) + ((s = s.slice(j)).length ? b : "")) {
      j = c == 2 || (j = s.slice(0, m + 1).match(/\S*(\s)?$/))[1] ? m : j.input.length - j[0].length || c == 1 && m || j.input.length + (j = s.slice(m).match(/^\S*/)).input.length;
    }
  }
  return trimBlanks(r.join("\n"));
}